﻿/*
 * Made By Parsa Yazdani
 * 
 * Infinite while loops and try/catch statements are frequently used together in this code.
 * They are used to handle errors (mainly to check for invalid user input).
 * The first instance of this is commented, the rest follow the same logic.
*/

using System;
using System.IO;

namespace Assessment_Term_1
{
    class Program
    {
        static void Main(string[] args)
        {
            // Setting variables
            Random rand = new Random();
            int questionsLeft;
            int cleaninput;
            long startTime = 0;
            int highScore = 0;
            int questionsCorrect = 0;
            int questionsWrong = 0;
            int cleanmin_num1 = 1;
            int cleanmax_num1 = 12;
            int cleanmin_num2 = 1;
            int cleanmax_num2 = 12;
            bool alreadyRun = false;
            while (true)
            {
                while (true) // Loop forever
                {
                    try // Run script
                    {
                        Console.WriteLine("How many questions? (-1 for infinite)");
                        string questionCount = Console.ReadLine();
                        questionsLeft = Int32.Parse(questionCount);
                        break; // If no errors occured in the last few lines, end the loop
                    }
                    catch // Output error and retry
                    {
                        Console.WriteLine("Invalid characters detected.");
                    }
                }
                while (questionsLeft != 0 && questionsLeft != -1) // Loop till all questions have been asked (unless user wrote -1)
                {
                    try
                    {
                        if (!alreadyRun) // Check this is the first time looping
                        {
                            while (true)
                            {
                                try
                                {
                                    Console.WriteLine("Would you like customise the questions? Type Y or N");
                                    string input = Console.ReadLine();
                                    if (input == "Y" || input == "y")
                                    {
                                        // Set minimum limit for first number
                                        while (true)
                                        {
                                            try
                                            {
                                                Console.WriteLine("Minimum limit for first number:");
                                                string min_num1 = Console.ReadLine();
                                                cleanmin_num1 = Int32.Parse(min_num1);
                                                break;
                                            }
                                            catch
                                            {
                                                Console.WriteLine("Invalid characters detected.");
                                            }
                                        }
                                        // Set maximum limit for first number
                                        while (true)
                                        {
                                            try
                                            {
                                                Console.WriteLine("Maximum limit for first number:");
                                                string max_num1 = Console.ReadLine();
                                                cleanmax_num1 = Int32.Parse(max_num1);
                                                break;
                                            }
                                            catch
                                            {
                                                Console.WriteLine("Invalid characters detected.");
                                            }
                                        }
                                        // Set minimum limit for first number
                                        while (true)
                                        {
                                            try
                                            {
                                                Console.WriteLine("Minimum limit for second number:");
                                                string min_num2 = Console.ReadLine();
                                                cleanmin_num2 = Int32.Parse(min_num2);
                                                break;
                                            }
                                            catch
                                            {
                                                Console.WriteLine("Invalid characters detected.");
                                            }
                                        }
                                        // Set maximum limit for first number
                                        while (true)
                                        {
                                            try
                                            {
                                                Console.WriteLine("Maximum limit for second number:");
                                                string max_num2 = Console.ReadLine();
                                                cleanmax_num2 = Int32.Parse(max_num2);
                                                break;
                                            }
                                            catch
                                            {
                                                Console.WriteLine("Invalid characters detected.");
                                            }
                                        }
                                    }
                                    else if (input == "N" || input == "n")
                                    {
                                        break;
                                    }
                                    else
                                    {
                                        Int32.Parse("a"); // Intentionally throw an error to be caught
                                    }
                                    break;
                                }
                                catch
                                {
                                    Console.WriteLine("Invalid characters detected.");
                                }
                            }
                        }

                        // Generate random numbers
                        int num1 = rand.Next(cleanmin_num1, cleanmax_num1++);
                        int num2 = rand.Next(cleanmin_num2, cleanmax_num2++);

                        // Begin timer
                        if (!alreadyRun)
                        {
                            alreadyRun = true;
                            Console.WriteLine("Are you ready? Click enter to begin!");
                            Console.ReadLine();
                            Console.WriteLine("Go!");
                            startTime = DateTimeOffset.Now.ToUnixTimeSeconds();
                        }

                        // Ask questions
                        while (true)
                        {
                            try
                            {
                                Console.WriteLine(num1 + "x" + num2);
                                string input = Console.ReadLine();
                                cleaninput = Int32.Parse(input);
                                break;
                            }
                            catch
                            {
                                Console.WriteLine("Invalid characters detected.");
                            }
                        }

                        // Check answer
                        if (cleaninput == num1 * num2)
                        {
                            Console.WriteLine("Correct");
                            questionsCorrect++; // Add to correct answer counter
                        }
                        else
                        {
                            Console.WriteLine("Wrong. The answer is " + num1 * num2 + ".");
                            questionsWrong++; // Add to incorrect answer counter
                        }

                        questionsLeft--;  // Lower amount of questions that need to be asked by 1
                    }
                    catch
                    {
                        Console.WriteLine("Invalid characters detected.");
                    }
                }

                int totalQuestions = questionsCorrect + questionsWrong; // Count total questions asked

                string directory = "highscore";
                if (!Directory.Exists(directory))
                {
                    Directory.CreateDirectory(directory);
                }

                string highScoreFileName = "" + totalQuestions + "_" + cleanmin_num1 + "_" + cleanmax_num1 + "_" + cleanmin_num2 + "_" + cleanmax_num2 + ".txt";
                string highScorePath = Path.Combine(directory, highScoreFileName);


                // Check high score - https://stackoverflow.com/questions/7569904/easiest-way-to-read-from-and-write-to-files/7569938
                if (File.Exists(highScorePath))
                {
                    using (StreamReader readtext = new StreamReader(highScorePath))
                    {
                        highScore = Int32.Parse(readtext.ReadLine());
                    }
                }
                else
                {
                    File.Create(highScorePath).Close();
                }

                // Update high score if beaten
                if (highScore < questionsCorrect)
                {
                    using (StreamWriter writetext = new StreamWriter(highScorePath))
                    {
                        writetext.WriteLine(questionsCorrect);
                    }
                    highScore = questionsCorrect;
                }

                // Calculate time taken
                long currentTime = DateTimeOffset.Now.ToUnixTimeSeconds();
                long timeDifference = currentTime - startTime;

                // Output stats
                Console.WriteLine("Beat High Score of " + highScore);
                Console.WriteLine("Finished. You got " + questionsCorrect + " of " + totalQuestions + " correct.");
                Console.WriteLine("High Score: " + highScore);
                if (timeDifference < 90)
                    Console.WriteLine("You took " + timeDifference + " seconds, well done!");
                else
                    Console.WriteLine("You took " + (timeDifference / 60) + " minutes, well done!");

                // Ask user if they want to retry
                try
                {
                    Console.WriteLine("Would you like to try again? Type Y or N");
                    string input = Console.ReadLine();
                    if (input == "Y" || input == "y")
                    {

                    }
                    else if (input == "N" || input == "n")
                    {
                        break;
                    }
                    else
                    {
                        Int32.Parse("a"); // Intentionally throw an error to be caught
                    }
                }
                catch
                {
                    Console.WriteLine("Invalid characters detected.");
                }
            }
        }
    }
}